import type { GomokuDirectionType } from './constant';
import type { GomokuContext } from './GomokuContext';
import type { IScoreMap, IShapeCount } from './types';
export declare class GomokuCountMap {
    protected readonly context: Readonly<GomokuContext>;
    protected readonly dirCountMap: Uint32Array[];
    protected readonly conShapeCountMap: IShapeCount[][];
    protected readonly gapShapeCountMap: IShapeCount[][];
    protected readonly scoreMap: IScoreMap;
    constructor(context: Readonly<GomokuContext>, scoreMap: IScoreMap);
    init(): void;
    beforeForward(id: number): void;
    afterForward(id: number): void;
    beforeRollback(id: number): void;
    afterRollback(id: number): void;
    score(scoreForPlayer: number): number;
    hasReachedTheLimit(player: number): boolean;
    toJSON(): {
        dirCountMap: Uint32Array[];
        conShapeCountMap: IShapeCount[][];
        gapShapeCountMap: IShapeCount[][];
    };
    protected updateRelatedConShapeCountMap(centerId: number, dirType: GomokuDirectionType, v: number): void;
    protected updateConShapeCountMap(startId: number, dirType: GomokuDirectionType, v: number): void;
    protected updateRelatedGapShapeCountMap(centerId: number, dirType: number, v: number): void;
    protected detectGapShape(id: number, dirType: number, v: number): void;
    protected updateGapShapeCountMap(startId: number, cnt1: number, cnt2: number, dirType: GomokuDirectionType, v: number): void;
    protected countFreeSide(player: number, startId: number, cnt: number, dirType: number): number;
}
