import { GomokuContext } from './GomokuContext';
import { GomokuState } from './GomokuState';
import type { IGomokuPiece, IScoreMap } from './types';
export declare class GomokuSolution {
    protected readonly MAX_DEPTH: number;
    protected readonly context: GomokuContext;
    protected readonly state: GomokuState;
    protected readonly stateCache: Map<bigint, number>;
    protected scoreForPlayer: number;
    protected bestMoveId: number | null;
    constructor(MAX_ROW: number, MAX_COL: number, MAX_INLINE?: number, MAX_DEPTH?: number, MAX_NEXT_MOVER_BUFFER?: number, scoreMap?: IScoreMap);
    init(pieces: ReadonlyArray<IGomokuPiece>): void;
    forward(r: number, c: number, p: number): void;
    rollback(r: number, c: number): void;
    minimaxSearch(nextPlayer: number): [r: number, c: number];
    protected alphaBeta(player: number, alpha: number, beta: number, cur: number, stateScore: number): number;
}
