import type { GomokuContext } from './GomokuContext';
import { GomokuCountMap } from './GomokuCountMap';
import type { IGomokuCandidateState, IGomokuPiece, IScoreMap } from './types';
declare type ICandidateScore = [s00: number, s01: number, s10: number, s11: number];
export declare class GomokuState {
    protected readonly context: GomokuContext;
    protected readonly countMap: GomokuCountMap;
    protected readonly candidateMap: Map<number, ICandidateScore>;
    constructor(context: GomokuContext, scoreMap: IScoreMap);
    init(pieces?: ReadonlyArray<IGomokuPiece>): void;
    forward(id: number, player: number): void;
    rollback(id: number): void;
    expand(nextPlayer: number, scoreForPlayer: number): IGomokuCandidateState[];
    score(currentPlayer: number, scoreForPlayer: number): number;
    isWin(currentPlayer: number): boolean;
    isDraw(): boolean;
    isFinal(): boolean;
    protected _scoreForCandidate(stateScore0: number, stateScore1: number, id: number): ICandidateScore;
    protected _reAppriseCandidates(centerId: number): void;
    protected _forward(id: number, player: number): void;
    protected _rollback(id: number): void;
    protected _beforeForward(id: number): void;
    protected _afterForward(id: number): void;
    protected _beforeRollback(id: number): void;
    protected _afterRollback(id: number): void;
}
export {};
